;====================================================================

;Voyage 200 Executables Patcher by Olivier Armand (ExtendeD) -
;<ola.e-ml@wanadoo.fr>

;current version : 0.12
;Initial Date: 03/17/2002
;Last Update : 02/27/2003

;YOU ARE NOT ALLOWED TO USE OR MODIFY ANY PART OF THIS SOURCE CODE
;WHITOUT MY AUTHORIZATION.

;VOUS N'ETES PAS AUTORISES A UTILISER OU MODIFIER CES SOURCES SANS
;MON AUTORISATION.

;=====================================================================


; *********************
; * Assembly Routines * 
; *********************

	section	".data"

	xdef		DoPatch

; Sorry, comments are in French, e-mail if you need details.
	
;Les types de routines de detection de calc qui peuvent etre patchees sont:

; 1)	and.l/andi.l #$600000,reg
;	instruction (6 octets maxi)
;	cmp.l/cmpi.l #$200000/$400000,reg
;	bne/beq.s/.w Label ou sne/seq reg
;
; 2)	cmp.l/cmpi.l #$200000/$400000,reg
;	bne/beq.s/.w Label ou sne/seq reg
;mais qui soit  moins de MAX_FROM_PREV_PATCH octets d'un autre patch de type 1)
;(on dtecte ainsi les optimisations dues  plusieurs tests de calc)
;
; 3)	and.l/andi.l #$400000,reg
;	bne/beq.s/.w Label ou sne/seq reg

;d1.b indique toujours le type de patch (nop ou bra)  effectuer.
;on l'utilise aussi pour viter la recherche du cmp pour un type 3)
;a2 pointe toujours sur l'adresse du dernier patch de type 1) ou 2) effectu.

MAX_FROM_PREV_PATCH	equ	28

;DoPatch :
;input : a0.l = dbut de la zone  patcher
;        a1.l = fin de la zone  patcher
;ouput : d0.w = nombre de patchs effectus

DoPatch:
	movem.l		d3-d4/a2,-(a7)
	moveq		#0,d0			;nombre de patchs
	suba.l		a2,a2	;adresse du dernier patch (pas de dernier patch)
\CalcDPatchLoop:
	cmp.l		#$400000,(a0)		;and du type 3) ou cmp du type 2)
	sne		d1
	beq.s		\TypeOk
	cmp.l		#$200000,(a0)		;cmp du type 2)
	beq.s		\ChkType2
	cmp.l		#$600000,(a0)		;and du type 1)
	bne		\NextWord2
\TypeOk:
;	bra.s		\TypeOk
	move.w		-2(a0),d2
	move.w		d2,d3
	move.w		d3,d4
	andi.w		#%1111000111111111,d3	;and.l #,reg ?
	cmp.w		#%1100000010111100,d3
	beq.s		\IsAnd
	andi.w		#%1111111111111000,d4	;andi.l #,reg ?
	cmp.w		#%0000001010000000,d4
	beq.s		\IsAnd
	cmp.l		#$600000,(a0)
	beq		\NextWord2		;ne peut pas tre un type 2)
\ChkType2:
	move.l		a2,d3
	add.l		#MAX_FROM_PREV_PATCH,d3
	cmp.l		d3,a0
	bhi		\NextWord2	;trop loin pour tre une optimisation
	move.w		d2,d3			;mot trait
	andi.w		#%1111000111111111,d3	;cmp.l #,reg ? 
	cmp.w		#%1011000010111100,d3
	beq.s		\SearchBcc
	andi.w		#%1111111111111000,d2	;cmpi.l #,reg ?
	cmp.w		#%0000110010000000,d2
	bne		\NextWord2
	bra.s		\SearchBcc
	;pas besoin de modifier d1.b, le bout de code aprs \CalcDPatchLoop
	;le calibre parfaitement, et a tombe bien.
					
\IsAnd:
	addq.l		#4,a0
	moveq		#0,d2			;indique type 3)
	tst.b		d1
	beq.s		\ReadyToPatch		;si $400000,on peut y aller
	moveq		#3,d4
\SearchCmp:					;si autre instuction entre
	move.w		(a0)+,d2
	move.w		d2,d3
	andi.w		#%1111000111111111,d3	;cmp.l #,reg ? 
	cmp.w		#%1011000010111100,d3
	beq.s		\IsCmp
	andi.w		#%1111111111111000,d2	;cmpi.l #,reg ?
	cmp.w		#%0000110010000000,d2
	dbeq.w		d4,\SearchCmp
\IsCmp:
	bne.s		\NextWord
	cmp.l		#$400000,(a0)
	seq		d1
	bne.s		\Not400000
\SearchBcc:
	addq.l		#4,a0
	moveq		#-1,d2			;indique type 1) ou 2)
\ReadyToPatch:
	cmp.b		#%01100111,(a0)		;beq ?
	beq.s		\IsBeq
	move.w		(a0),d3
	andi.w		#%1111111111111000,d3
	cmp.w		#%0101011111000000,d3	;seq reg?
	bne.s		\TstSne
\SccPatch:
	tst.b		d1
	beq.s		\PatchClr
	andi.w		#%1111000011111111,(a0)+ ;st reg
	bra.s		\Patched
\PatchClr:
	andi.w		#%0100001000111111,(a0)+ ;clr.b reg
	bra.s		\Patched
\TstSne:
	cmp.w		#%0101011011000000,d3	;sne reg?	
	bne.s		\TstBne
	not.b		d1			;patch inverse de celui pour seq
	bra.s		\SccPatch
	
\IsBeq:
	tst.b		d1
	bne.s		\PatchBra
\PatchNop:
	move.w		#$4e71,(a0)+		;nop
\Patched:
	tst.b		d2			;type 3) ?
	beq.s		\NoPatchAdSave		;oui
	move.l		a0,a2			;adresse du dernier patch
\NoPatchAdSave:
	addq.w		#1,d0
	bra.s		\NextWord3
\TstBne:
	cmp.b		#%01100110,(a0)		;bne ?
	bne.s		\NextWord3
	tst.b		d1
	bne.s		\PatchNop
\PatchBra:
	andi.w		#%1111000011111111,(a0)+ ;bra.s
	bra.s		\Patched

\Not400000:
	cmp.l		#$200000,(a0)
	bne.s		\NextWord3
	bra.s		\SearchBcc
	
\NextWord:
	lea		-10(a0),a0
\NextWord2:
	addq.l		#2,a0
\NextWord3:
	cmp.l		a0,a1
	bhi		\CalcDPatchLoop
	movem.l		(a7)+,d3-d4/a2
	rts
